<CsoundSynthesizer>
; coded by Oeyvind Brandtsegg 2001, revised 2002
; originally coded in MAX during 1999

; You need some specific soundfiles to run this orchestra,
; they should be distributed together with the csd file.
; Edit the lines of text following after the <CsScore> tag to 
; reflect the path where you have put these files.
; example:
; f1  0  0    1  "E:/SamplesLive/Kroyt/Silent_live/SilentEQ.WAV"  0  0  0
; edit the text between the quote marks (")

; pardon for the very messy Csound code.
; This is a Csound setup for one song with the band Kroyt.
; It needs midi in and audio out
; Originally, I used midi out too, to control proramg chanes and parameter 
; control of an external effects unit used on my Vibraphone.
; Now this orchestra has been used with CsoundVST, and midi mappings have been done
; outside of Csound, in the track parameters of Cubase. Cubase is used merely as 
; a VST host for Csound, and for midi thru.

; At startup of this orchestra, you will not be able to hear any notes played via midi.
; Use midi controller 6 to control volume of a synth pad sound.
; Use midi controller 3 to start a background audio loop fading in,
; this is a toggle switch so that each time it goes above the value of 20, 
; the loop will alternately start or stop.
; Use midi controller 2, with a value > 20 to change the background loop,
; be patient when trying thism, as the loop will 
; play to it's end before changing to the next one.
; Everything is to be played on midi channel 1

; During a normal show, I use DimesionBeam infrared midi controllers to control start/stop, and 
; advance (or "trig next loop"). These send midi controller 2 and controller 3.
; I also use a BodySynth (EMG, muscle activity sensors) to send midi controllers 6 and 7,
; controller 6 affects volume on the synth pad in this orchestra,
; and it also controls a pitch shifth and delay algorithm on an external effects unit.
; Controller 7 controls only parameters on the external effects unit 
; used to process audio from my Vibraphone.

<CsOptions>

;CsoundAV command line, edit to suit your platform and choice of Csound version
-+X -+K -b2048
;enable midi in and audio out

</CsOptions>

<CsInstruments>

	sr = 44100  
	kr = 441
	ksmps = 100
	nchnls = 2	

;	massign	1,1

	massign	1, 361
	zakinit	13,1

	gktrig2	init 1
	gi_hold	init 0
	gktrig3	init 0
	gkout_ndx init 0
	gkout_fno1 init 1
	gkout_amp1 init 0
	gkampmod init 0

	gkdb2	init 0
	gkdb3	init 0

;*********************************************************	
;************* control section ***************************
;*********************************************************	

;*********************************************************	
;*********************************************************	
instr 1

inum	notnum
print inum
icps	cpsmidi
iamp	ampmidi	28000

a1	oscil	iamp, icps, 93

ktrg2	= ( inum == 60 ? 1 : 0 )
ktrg3	= ( inum == 61 ? 1 : 0 )

ktrig2	trigger	ktrg2, 0.5, 0
ktrig3	trigger	ktrg3, 0.5, 0

schedkwhen	ktrig2, 0, 1, 2, 0, 1, 2
schedkwhen	ktrig3, 0, 1, 2, 0, 1, 3

outs	a1, a1

endin
;********************************************

;********************************************
instr 2

isel	= p4
if isel == 2 goto kdb2
if isel == 3 goto kdb3
kdb2:
gkdb2	linseg	0, 0.5, 100, 0.5, 0, 1, 0
goto end
kdb3:
gkdb3	linseg	0, 0.5, 100, 0.5, 0, 1, 0
goto end
end:
;********************************************


; Program setup

;	outipc	2, 98, 0, 127		; program change to TC Fireworx

;	outic 	3, 32, 0, 0, 127	; bank change to Wavestaion
;	outipc	3, 73, 0, 127		; program change to Wavestaion
;					; -1 mapping compared to max
	endin

;*********************************************************	
;*********************************************************	
	instr 3		; Midi controllers

kdb2	ctrl7	1, 2, 0, 127			;ch1, midi ctrl, min, max
kdb3	ctrl7	1, 3, 0, 127			;ch1, midi ctrl, min, max

;kdb2	= gkdb2
;kdb3	= gkdb3

;** db2 advances the index value pointing to the 
; arrangement of samplenumbers(ifno) and amplitudes for instr 10
;************************************
ktrig2	trigger	kdb2, 20, 0		; make trigger of db2 signal
gktrig2	= gktrig2 + ktrig2		; accumulate trigger events 
					; this faciliates the init-value of gktrig to be 1
					; and to reset to zero after the first set of
					; values has been sent to instr 10

		; trigseq selects samples and amplitudes for the oscillator
		; when db2 is activated,
		; trigseq will apply new values to ifno1/iamp1
		; these values are read in sets of 3 from table 78 (first value is the "group index")

;trigseq	gktrig2,  0,  260, 0,  88, kout_ndx, kout_fno1, kout_amp1	;get values from table
;gkout_fno1	= kout_fno1				; hack, because trigseq does not work with global output signals
;gkout_amp1	= kout_amp1	

gktrigindx	init -3
gktrigindx	= gktrigindx + (gktrig2*3)
kout_ndx	table	gktrigindx, 78
gkout_fno1	table	gktrigindx+1, 78
gkout_amp1	table	gktrigindx+2, 78

gktrig2		= 0					; reset gktrig2 after sending values to instr 10
printk2	kout_ndx, 50

; ** kout_ndx controls amplitude fade in and out
;************************************
kampin		= (kout_ndx+gktrig3 == 1 ? 1 : 0)		; if kout_ndx = 0 , and gktrig3 = 1
ktrig_ampin	trigger	kampin, 0.5, 0				; make trigger of kampin signal
kampout		= (kout_ndx*gktrig3 == 5 ? 1 : 0)		; if kout_ndx = 4 , and gktrig3 = 1
ktrig_ampout	trigger	kampout, 0.5, 0				; make trigger of kampout signal
schedkwhen	ktrig_ampin, 0, 1, 5, 0, 20			; note on instr 5 (ampmod, fade in)
schedkwhen	ktrig_ampout, 0, 1, 6, 0, 20			; note on instr 6 (ampmod, fade out)


;** db3 trig basic playback start
;************************************

ktrig3	trigger	kdb3, 20, 0		; make trigger of db3 signal
gktrig3	= gktrig3 + ktrig3 		; accumulate trigger events 
gktrig3	= (gktrig3 > 1 ? 0 : gktrig3)	; limit to 1, creates a toggle switch (0,1,0,1,0,1,0...)

schedkwhen	gktrig3, 0, 1, 4, 0, -1		; note on instr 4 (metro)


;***BodySynth thru to Fireworx & Wavestation
;************************************
;kbs2	ctrl7	1, 7, 0, 127			;ch, midi ctrl, min, max
;outkc 	2, 4, kbs2, 0, 127			;send midi ctrl value to TC (ch2)

;kbs1	ctrl7	1, 6, 0, 127			;ch, midi ctrl, min, max
;outkc	3, 7, kbs1, 0, 50			;send midi ctrl value to Ws (ch3)

;***BodySynth controls amplitude on Pad, instr 361
;************************************
kbs1	ctrl7	1, 6, 0, 1			;ch, midi ctrl, min, max
kbs1a	port	kbs1, 0.1
gkPadAmp	= kbs1a


	endin

;*********************************************************	
;*********************************************************	

;****************************************************************
; metro trigging drumloops
;****************************************************************

	instr 4
itime	= 11.755

kmetro	seqtime	itime, 0, 3, 0, 90 		; metronome-trigger, tempo set by itime
kmetrot	trigger kmetro, 0.9, 0

schedkwhen	kmetrot, 0, 1, -10, 0, 1	; note off instr 10 
schedkwhen	kmetrot, 0, 0, 10, 0, -1	; note on instr 10

schedkwhen	1-gktrig3, 0, 1, -10, 0, 1	; note off instr 10 if gktrig3 = 0
schedkwhen	1-gktrig3, 0, 1, -4, 0, 1	; instr 4 turn off itself if gktrig3 = 0

	endin

;*********************************************************	
;*********************************************************	

;****************************************************************
; ampmod instr, fade in
;****************************************************************

	instr 5
	gkampmod line 0, p3, 1
	endin

;*********************************************************	
;*********************************************************	

;****************************************************************
; ampmod instr, fade out
;****************************************************************

	instr 6
	gkampmod line 1, p3, 0
	endin

;*********************************************************	
;*********************************************************	

;*********************************************************	
;**************** audio processing ***********************
;*********************************************************

;****************************************************************
;Silent drumloops
;****************************************************************
	instr	10

iamp	= 20000			; overall iamp


; the following values was generated in instr 3
ifno1	= i(gkout_fno1)
iamp1	= i(gkout_amp1) * iamp

; audio playback section
;a_amp1	linenr	iamp1, 0.001, 0.05, 0.01
a_amp1	= iamp1
a_amp1	= a_amp1 * gkampmod
iorig	init 440	
a1,a2	loscil	a_amp1, iorig, ifno1, iorig

	outs	a1, a2


;** control section for turning off metro-trigging (instr 4) when song has ended
;************************************

gi_hold	= (i(gkout_ndx) == 4 ? 1 : 0)	; if arrangement-pointer is at 2 (after bridge)
k_hold	= gi_hold			; hack, to enable delay of i-time variable
a_hold	upsamp	k_hold			; neccessary because there is no k-rate delay opcode
a_hold	delay	a_hold, 20		; delay hold-metronome-signal
k_hold	downsamp a_hold
if k_hold > 0 goto stop			; do this only if gk_ndx == 10
goto contin				; else goto normal/clean endin

stop:
gktrig3	= gktrig3 + 1				; adding 1 to gktrig toggles the on/off playback switch in instr 3
;following changes 2.okt.2002 0:09
schedkwhen	1-gktrig3, 0, 1, -4, 0, 1	; instr 4 turn off 
turnoff						; turnoff self

contin:
	endin
;****************************************************************
;****************************************************************


;****************************************************************
; Pad 1, played via midi, efx sends in GUI (same as instr 60)
;****************************************************************
	instr 361

inum	notnum
icps	cpsmidi
iamp	ampmidi	4500
kamp	linenr	iamp, 0.01, 0.7, 0.01
kamp	= kamp * gkPadAmp			; Amp modified by BodySynth input
;iorig	= 523.251	; C
;iorig	= 261.6256	;
iorig	= 65.4064
ifno	= int((inum / 12)) - 2 ; note num 35 gets ifno 1, +1 for each octave over
ifno	= (ifno > 6 ? 6 : ifno)
ifno	= (ifno < 1 ? 1 : ifno)
ioct	pow	2, ifno
ioct	= ioct * 0.5
iorig	= iorig * ioct
icps1	= icps * 1.0001
icps2	= icps * 0.9999

a1	loscil	kamp, icps1, ifno + 83, iorig
a2	loscil	kamp, icps2, ifno + 83, iorig
ao	= (a1 + a2) * 0.5 

;EFX and dry out amplitudes

gkpd1_pan	= 0.5	; Pad panning
gkpd1_clean 	= 1	; send to clean out 
gkpd1_rm	= 0	; send to RingMod
gkpd1_fm	= 0	; send to FreqMod	
gkpd1_filt1	= 0.3	; send to Filter1	
gkpd1_dist	= 0	; send to Distortion	
gkpd1_filt2	= 0	; send to Filter2	
gkpd1_del1	= 0	; send to Delay1	
gkpd1_del2	= 0	; send to Delay2	
gkpd1_revb	= 0.3	; send to Reverb

	zawm	a1 * gkpd1_clean * (1-gkpd1_pan), 4	; send to clean out Left
	zawm	a2 * gkpd1_clean * gkpd1_pan, 	5	; send to clean out Right
;	zawm	ao * gkpd1_rm	, 		6	; send to RingMod
;	zawm	ao * gkpd1_fm	, 		7	; send to FreqMod	
	zawm	ao * gkpd1_filt1, 		8	; send to Filter1	
;	zawm	ao * gkpd1_dist	, 		9	; send to Distortion	
;	zawm	ao * gkpd1_filt2, 		10	; send to Filter2	
;	zawm	ao * gkpd1_del1	, 		11	; send to Delay1	
;	zawm	ao * gkpd1_del2	, 		12	; send to Delay2	
	zawm	ao * gkpd1_revb	, 		13	; send to Reverb

	endin
;****************************************************************
;****************************************************************

;****************************************************************
; EFX channel "keep it alive instr", 
;****************************************************************
; this instr runs bogus/unhearable audio values through the efx/output channels
; this stabilizes the audio patching channels and thus avoids dropouts
; .... it's to prevent underflow in calculations

	instr 401

iamp	= 0.1

a1	 rand	iamp

;EFX and dry out amplitudes

	zawm	a1, 4	; send to clean out Left
	zawm	a1, 5	; send to clean out Right
	zawm	a1, 6	; send to RingMod
	zawm	a1, 7	; send to FreqMod	
	zawm	a1, 8	; send to Filter1	
	zawm	a1, 9	; send to Distortion	
	zawm	a1, 10	; send to Filter2	
	zawm	a1, 11	; send to Delay1	
	zawm	a1, 12	; send to Delay2	
	zawm	a1, 13	; send to Reverb

	endin
;****************************************************************
;****************************************************************


;****************************************************************
; Filter 1  instr
;****************************************************************
	instr 493

	a1	zar	8

;	kfreq	= gkfx_f1_cfrq				; filter freq
;	kq	= gkfx_f1_q*(kfreq*0.5)			; filter Q
	kfreq	= 650				; filter freq
	kq	= 0.02*(kfreq*0.5)			; filter Q

;	krms	rms	a1, 5				; get rms of input signal
;	kampmod	= krms * gkfx_f1_afrq / 32000		; amount of amp->freq
;	kfreq	= kfreq + (kfreq*kampmod)		; input amp modifies freq

;	klfo	oscil	gkfx_f1_lamt, gkfx_f1_lfrq, 93	; make lfo
	klfo	oscil	0.3, 0.2, 93			; make lfo
	kfreq 	= kfreq + (kfreq*klfo)			; lfo modifies freq
	kfreq	= (kfreq > 20000 ? 20000 : kfreq)	; limit upper range to 20000
	kfreq	= (kfreq < 20 ? 20 : kfreq)		; limit lower range to 20

	alp,ahp,abp	svfilter	a1, kfreq, kq
	alp	balance	alp, a1
	abp	balance	abp, a1
	ahp	balance	ahp, a1
;	ares	mac	gkfx_f1_lp, alp, gkfx_f1_bp, abp, gkfx_f1_hp, ahp	; add and multiply
	klp	= 0
	kbp	= 1
	khp	= 0.7
	ares	mac	klp, alp, kbp, abp, khp, ahp	; add and multiply

	zawm	ares , 	4	; send to clean out Left
	zawm	ares , 	5	; send to clean out Right
;	zawm	ares * gkfx_f1_dist, 			9	; send to Distortion	
;	zawm	ares * gkfx_f1_flt2, 			10	; send to Filter2	
;	zawm	ares * gkfx_f1_dly1, 			11	; send to Delay1	
;	zawm	ares * gkfx_f1_dly2, 			12	; send to Delay2	
	zawm	ares * 0.2 , 			13	; send to Reverb

	endin
;****************************************************************
;****************************************************************

;****************************************************************
; WG reverb instr
;****************************************************************

; 8 delay line FDN reverb, with feedback matrix based upon 
; physical modeling scattering junction of 8 lossless waveguides
; of equal characteristic impedance. Based on Julius O. Smith III, 
; "A New Approach to Digital Reverberation using Closed Waveguide
; Networks," Proceedings of the International Computer Music 
; Conference 1985, p. 47-53 (also available as a seperate
; publication from CCRMA), as well as some more recent papers by
; Smith and others.
;
; Coded by Sean Costello, October 1999.
; Small modifications by Oeyvind Brandtsegg, 2001.

	instr 498        

gkfx_rv_pdly	= 0.1
gkfx_rv_lf	= 140
gkfx_rv_tim	= 0.92
gkfx_rv_pmod	= 0.98
gkfx_rv_hf	= 7000

ain	zar	13			; input signal

kpre	= gkfx_rv_pdly*1000		; predelay is in millisecs
a1	vdelay	ain, kpre, 1000		; Pre Delay

inlevl	= 0.5				; input level
ioutlevl = 0.5				; output level
klfroll		tonek gkfx_rv_lf, 0.1	; LF rolloff freq

kgain 		tonek gkfx_rv_tim, 0.1	; gain of reverb. Adjust empirically
                			; for desired reverb time. .6 gives
                			; a good small "live" room sound, .8
                			; a small hall, .9 a large hall,
                			; .99 an enormous stone cavern.

kpitchmod	tonek gkfx_rv_pmod, 0.1	; amount of random pitch modulation
                			; for the delay lines. 1 is the "normal"
                			; amount, but this may be too high for
                			; held pitches such as piano tones.
                			; Adjust to taste.

ktone 		tonek gkfx_rv_hf, 0.1	; Cutoff frequency of lowpass filters
                			; in feedback loops of delay lines,
                			; in Hz. Lower cutoff frequencies results
                			; in a sound with more high-frequency
                			; damping.

        
afilt1 init 0
afilt2 init 0
afilt3 init 0
afilt4 init 0
afilt5 init 0
afilt6 init 0
afilt7 init 0
afilt8 init 0

; Delay times chosen to be prime numbers.
; Works with sr=44100 ONLY. If you wish to
; use a different delay time, find some new
; prime numbers that will give roughly the
; same delay times for the new sampling rate. 
; Or adjust to taste.
idel1 = (2473.000/sr)
idel2 = (2767.000/sr)
idel3 = (3217.000/sr)
idel4 = (3557.000/sr)
idel5 = (3907.000/sr)
idel6 = (4127.000/sr)
idel7 = (2143.000/sr)
idel8 = (1933.000/sr)

; k1-k8 are used to add random pitch modulation to the
; delay lines. Helps eliminate metallic overtones
; in the reverb sound.
k1      randi   .001, 3.1, .06
k2      randi   .0011, 3.5, .9
k3      randi   .0017, 1.11, .7
k4      randi   .0006, 3.973, .3
k5      randi   .001, 2.341, .63
k6      randi   .0011, 1.897, .7
k7      randi   .0017, 0.891, .9
k8      randi   .0006, 3.221, .44

; apj is used to calculate "resultant junction pressure" for 
; the scattering junction of 8 lossless waveguides
; of equal characteristic impedance. If you wish to
; add more delay lines, simply add them to the following 
; equation, and replace the .25 by 2/N, where N is the 
; number of delay lines.
apj = .25 * (afilt1 + afilt2 + afilt3 + afilt4 + afilt5 + afilt6 + afilt7 + afilt8)

a1	= a1 * inlevl

adum1   delayr  1
adel1   deltapi idel1 + k1 * kpitchmod
        delayw  a1 + apj - afilt1

adum2   delayr  1
adel2   deltapi idel2 + k2 * kpitchmod
        delayw  a1 + apj - afilt2

adum3   delayr  1
adel3   deltapi idel3 + k3 * kpitchmod
        delayw  a1 + apj - afilt3

adum4   delayr  1
adel4   deltapi idel4 + k4 * kpitchmod
        delayw  a1 + apj - afilt4

adum5   delayr  1
adel5   deltapi idel5 + k5 * kpitchmod
        delayw  a1 + apj - afilt5

adum6   delayr  1
adel6   deltapi idel6 + k6 * kpitchmod
        delayw  a1 + apj - afilt6

adum7   delayr  1
adel7   deltapi idel7 + k7 * kpitchmod
        delayw  a1 + apj - afilt7

adum8   delayr  1
adel8   deltapi idel8 + k8 * kpitchmod
        delayw  a1 + apj - afilt8

; 1st order lowpass filters in feedback
; loops of delay lines.
afilt1  tone    adel1 * kgain, ktone
afilt2  tone    adel2 * kgain, ktone
afilt3  tone    adel3 * kgain, ktone
afilt4  tone    adel4 * kgain, ktone
afilt5  tone    adel5 * kgain, ktone
afilt6  tone    adel6 * kgain, ktone
afilt7  tone    adel7 * kgain, ktone
afilt8  tone    adel8 * kgain, ktone

; The outputs of the delay lines are summed
; and sent to the stereo outputs. This could
; easily be modified for a 4 or 8-channel 
; sound system.
aoutL = (afilt1 + afilt3 + afilt5 + afilt7) * ioutlevl 
aoutL buthp	aoutL, klfroll
aoutR = (afilt2 + afilt4 + afilt6 + afilt8) * ioutlevl 
aoutR buthp	aoutR, klfroll

;Send to output
	zawm	aoutL , 	4	; send to clean out Left
	zawm	aoutR , 	5	; send to clean out Right

endin
;****************************************************************
;****************************************************************

;****************************************************************
; dry out, stereo
;****************************************************************
	instr 499
a1	zar	4
a2	zar	5

outs	a1, a2
	endin
;****************************************************************
;****************************************************************


;****************************************************************
; clear zak
;****************************************************************
	instr 501
	zacl	0,13
	endin
;****************************************************************
;****************************************************************



</CsInstruments>

<CsScore>

f1   0  0    1  "E:/SamplesLive/Kroyt/Silent_live/SilentEQ.WAV"  0  0  0
f2   0  0    1  "E:/SamplesLive/Kroyt/Silent_live/Silent245Coolest.wav"  0  0  0
f3   0  0    1  "E:/SamplesLive/Kroyt/Silent_live/Silent245Cool.wav"  0  0  0
f4   0  0    1  "E:/SamplesLive/Kroyt/Silent_live/Silent245Hot_Nice.wav"  0  0  0
f84  0  0    1  "E:/SamplesLive/Ws/PadWsSeq1_C2.aif"  0  0  0
f85  0  0    1  "E:/SamplesLive/Ws/PadWsSeq1_C3.aif"  0  0  0
f86  0  0    1  "E:/SamplesLive/Ws/PadWsSeq1_C4.aif"  0  0  0
f87  0  0    1  "E:/SamplesLive/Ws/PadWsSeq1_C5.aif"  0  0  0
f88  0  0    1  "E:/SamplesLive/Ws/PadWsSeq1_C6.aif"  0  0  0
f89  0  0    1  "E:/SamplesLive/Ws/PadWsSeq1_C7.aif"  0  0  0


;f78 contains samplenumbers(ifno) and amplitudes in the following format:
;part_index ifno1 iamp1 
;part_index is not used in any instr, just for reference

f78 0 512  -2   
0   1 0.40
1   2 0.63
2   3 0.74
3   4 0.80
4   2 0.32
5   2 0.32



f90 0 4      2   0 1 0 1 		; trigseq delta times
f91 0 128    7   0   64   1   0   -1   64   0 		; saw
f92 0 128    7   0   0    1   64   1   0   -1   64   -1 ; square
f93 0 65536 10   1    		 	; sine
f94 0 128    7   1 64 1 0 -1 64 -1  	; square

f100 0 128 5   0.01 96  0.4 32 1
f101 0 128 9   0.25 1   0

; ***** ***** ******

i3 0 6000

i401  0 6000
;i491  0 6000
;i492  0 6000
i493  0 6000
;i494  0 6000
;i495  0 6000
;i496  0 6000
;i497  0 6000
i498  0 6000
i499  0 6000
i501 0 6000	; clear zak

e

</CsScore>


</CsoundSynthesizer>



























